# Rocketwheel Command

Command line tool for encoding, building and deploying player packages.

## Install

To install the gem:

```
gem install rocketwheel-command
```

To update the gem:

```
gem update rocketwheel-command
```

## Usage

**Versions**

Lists the various versions of the player.

```bash
rocket versions
```

**New**

Start a new project with the default template.

```bash
rocket new foobar
```

**Build**

Copies all files from the `./source` directory to the `./build` directory,
compiles any erb templates, and downloads and installs the player into the
`./build/demoplayer` directory.

```bash
rocket build
```

[ERB templates](http://www.stuartellis.eu/articles/erb/) (files ending in .tt, which have ruby code embedded) are rendered with the following local variables assigned:

* `player_options`: A hash of player options.
* `playlist`: An array of hashes, representing the playlist.
* `manifest`: The parsed Rocketfile.yml

**Encode**

Using [transloadit](http://transloadit.com), encodes all files in `./source/videos` and places them in `./build/videos`

```bash
rocket encode
```

By default, it will use [these](./templates/transloadit.yml) transloadit steps,
but you can override the steps by specifiying them as the `transloadit.steps`
key in the Rocketfile.yml. See the [transloadit docs](https://transloadit.com/docs)
for more information.

**Deploy**

Uploads all files in the `./build` directory to S3. Uses the credentials from
the `s3` key in your Rocketfile.yml.

```bash
rocket deploy
```

## Releasing

To release a new version of the gem:

1. Bump the version number in [./lib/rocketwheel/command/version.rb](./lib/rocketwheel/command/version.rb)
2. Commit changes

   ```bash
   git commit -am "Bumped version"
   ```
3. Push the gem to [rubygems](http://rubygems.org)

   ```bash
   rake release
   ```

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request
